package com.qmth.distributed.print.business.activiti;

import com.qmth.distributed.print.business.entity.ExamTask;
import com.qmth.distributed.print.business.entity.TFFlowApprove;
import com.qmth.distributed.print.business.entity.TFFlowApproveLog;
import com.qmth.distributed.print.business.entity.TFFlowLog;
import com.qmth.distributed.print.business.service.ExamTaskService;
import com.qmth.distributed.print.business.service.TFFlowApproveLogService;
import com.qmth.distributed.print.business.service.TFFlowApproveService;
import com.qmth.distributed.print.business.service.TFFlowLogService;
import com.qmth.teachcloud.common.contant.SpringContextHolder;
import org.activiti.engine.delegate.DelegateExecution;
import org.activiti.engine.delegate.ExecutionListener;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;
import java.util.StringJoiner;

/**
 * @Description: 子流程启动监听
 * @Param:
 * @return:
 * @Author: wangliang
 * @Date: 2021/11/19
 */
public class StartApproveSubListener implements ExecutionListener {
    private final static Logger log = LoggerFactory.getLogger(StartApproveSubListener.class);

    @Override
    @Transactional
    public void notify(DelegateExecution delegateExecution) {
        ExamTaskService examTaskService = SpringContextHolder.getBean(ExamTaskService.class);
        TFFlowApproveService tfFlowApproveService = SpringContextHolder.getBean(TFFlowApproveService.class);
        TFFlowApproveLogService tfFlowApproveLogService = SpringContextHolder.getBean(TFFlowApproveLogService.class);
        TFFlowLogService tfFlowLogService = SpringContextHolder.getBean(TFFlowLogService.class);

        TFFlowApprove flowApprove = tfFlowApproveService.findByFlowId(delegateExecution.getRootProcessInstanceId());
        TFFlowApproveLog tfFlowApproveLog = tfFlowApproveLogService.findByFlowId(delegateExecution.getRootProcessInstanceId());
        List<TFFlowLog> tfFlowLogList = tfFlowLogService.findByFlowId(delegateExecution.getRootProcessInstanceId());
        ExamTask examTask = examTaskService.findByFlowId(delegateExecution.getRootProcessInstanceId());
        String flowIds = new StringJoiner("").add(examTask.getFlowId()).add(",").add(delegateExecution.getProcessInstanceId()).toString();
        examTask.setFlowId(flowIds);
        examTaskService.updateById(examTask);

        flowApprove.setFlowId(flowIds);
        tfFlowApproveService.updateById(flowApprove);

        tfFlowApproveLog.setFlowId(flowIds);
        tfFlowApproveLogService.updateById(tfFlowApproveLog);

        tfFlowLogList.forEach(s -> s.setFlowId(flowIds));
        tfFlowLogService.updateBatchById(tfFlowLogList);
    }
}